#include <math.h>
#include <stdio.h>

#include "struct.h"
#include "data.h"
#include "defs.h"
#include "blood.h"
#include "point.h"

int blood_on= 1;
blood_t blood_dots[1000];
blood_t blood_pools[WINWIDTH];
double average_height, total_height;

/* You might have to look a while to find more high-ass code than this,
   but here's how it works.  blood_rect.location is the upper left corner,
   blood_rect.speed is the height and width. */
/*
  This needs to be fixed.
 */

void init_blood_pools(void)
  {
    int i;
    for(i=0; i<WINWIDTH; i++)
    {
      blood_pools[i].location.x= i;
      blood_pools[i].location.y= 0;
      blood_pools[i].speed.x= 1;
      blood_pools[i].speed.y= 0;
      blood_pools[i].color= W_Red;
      blood_pools[i].alive= 1;
    }
    average_height= 0;
    total_height= 0;
  }

/* Note:
   init_blood(), do_blood(), and many other functions should *not*
     have unchecked parameters! That's what empty () mean.
     Use 'the abmoninable f(void)'.
     Other functions not yet fixed.
 */
void init_blood(void)
  {
    int i;
    for(i=0; i<1000; i++)
    {
      blood_dots[i].alive = 0;
    }
    init_blood_pools();
    printf("blood inited\n");
  }

void create_blood(point_t location, int bloodiness)
  {
    bloodiness *= BLOOD_FACTOR;
    location.y += STATUS_BAR_HEIGHT;
    int i, n, last_n = 0;
    for(i = 0; i<bloodiness; i++)
    {
      for(n=last_n; n<1000; n++)
      {
        if(!blood_dots[n].alive)
        {
          double angle = (get_random(bloodiness) / (bloodiness/2.0)) * M_PI;
          blood_dots[n].location = location;
          blood_dots[n].speed.x = cos(angle) * 5;
          blood_dots[n].speed.y = sin(angle) * 5;
          blood_dots[n].color = W_Red;
          blood_dots[n].alive = 1;
          last_n = n + 1;
          // printf("blood_dots[%d] created.\n", n);
          break;
        }
      }
    }
  }

void change_pool_height(int x, int amount)
  {
    blood_pools[x].location.y-= amount;
    blood_pools[x].speed.y+= amount;
  }

void add_to_blood_pool(blood_t const* blood_dot)
  {
    int x= blood_dot->location.x;
    int i;
    for(i= 0; i<BLOOD_SIZE && i+x<WINWIDTH; i++)
    {
      // printf("Adding to blood_pools[%d]...", x+i);
      change_pool_height(x, BLOOD_SIZE);
      // printf("Success.\n");
    }
    total_height+= BLOOD_SIZE * BLOOD_SIZE;
    average_height= total_height / WINWIDTH;
  }

void flow_pool_top(int id, int dir)
  {
    // printf("flow_pool_top: dir: %d\n",dir);
    if(id + dir < 0)
    {
      dir= WINWIDTH - 1;
    }
    else if(id + dir > WINWIDTH - 1)
    {
      dir= -(WINWIDTH - 1);
    }
    // printf("Flowing %d from %d...", dir, id);
    /* Get the height difference. */
    int height_diff= blood_pools[id + dir].location.y - blood_pools[id].location.y;
    /* printf("height_diff between blood_pools[%d] and blood_pools[%d] is %d.\n"
       , id, id+dir, height_diff); */
    if(height_diff <= 1)
    {
      /* Blood does not flow uphill. */
      // printf("uphill, returning.\n");
      return;
    }
    change_pool_height(id + dir, height_diff / 2);
    change_pool_height(id, -(height_diff / 2));
    // printf("success.\n");
  }

void flow_pools(void)
  {
    int n;
    /* printf("counter is %d, counter%%3 is %d, !counter%%3 is %d.\n"
       , counter, counter%3, !(counter%3)); */
    /* Blood is viscous, and thus does not flow every frame. */
    /* Don't do it all at once, spread it out. */
    int viscosity= 1;
    int start= (WINWIDTH / viscosity) * (counter % viscosity);
    int end= start + (WINWIDTH / viscosity);
    end= (end > WINWIDTH) ? (WINWIDTH) : (end);
    // printf("blood_pools start is %d, end is %d.\n", start, end);
    for(n=start; n<end; n++)
    {
      /* On second thought, I don't care if the model is slightly inaccurate due to
         access order.  I'm only going to check the adjacent pools.  Somebody else
         can fix it if they want an accurate fluid model. */
      /* This replaces an if statement of the form if(counter%2) */
      int foo= ((counter & 2) << 1) - 1;
      /* counter%2 = 0 or 1
         0-.5 = -.5    1-.5 = .5
         -.5*2 = -1    .5*2 = 1 */
      if(n + foo < 0)
      {
        if(blood_pools[n].location.y < blood_pools[WINWIDTH-1].location.y)
        {
          flow_pool_top(n, foo);
          continue;
        }
      }
      if(n + foo > WINWIDTH)
      {
        if(blood_pools[n].location.y < blood_pools[0].location.y)
        {
          flow_pool_top(n, foo);
          continue;
        }
      }
      if(blood_pools[n].location.y < blood_pools[n + foo].location.y)
      {
        flow_pool_top(n, foo);
        continue;
      }
      if(n - foo < 0)
      {
        if(blood_pools[n].location.y < blood_pools[WINWIDTH-1].location.y)
        {
          flow_pool_top(n, -foo);
          continue;
        }
      }
      if(n - foo > WINWIDTH)
      {
        if(blood_pools[n].location.y < blood_pools[0].location.y)
        {
          flow_pool_top(n, -foo);
          continue;
        }
      }
      if(blood_pools[n].location.y < blood_pools[n - foo].location.y)
      {
        flow_pool_top(n, -foo);
        continue;
      }
    }
  }

void do_blood(void)
  {
    int i;
    int speed= 1;
    int start= (1000 / speed) * (counter % speed);
    int end= start + (1000 / speed);
    end= (end > 1000) ? (1000) : (end);
    // printf("counter is %d blood_dots start is %d, end is %d.\n", counter, start, end);
    for(i = start; i<end; i++)
    {
      if(blood_dots[i].alive)
      {
        if(!paused)
        {
          // printf("doing blood_dots[%d]...", i);
          blood_dots[i].speed.y++;
          blood_dots[i].location = point_add(blood_dots[i].location
            , blood_dots[i].speed);
          if(blood_dots[i].location.x < 0)
          {
            blood_dots[i].location.x+= WINWIDTH;
          }
          if(blood_dots[i].location.x > WINWIDTH)
          {
            blood_dots[i].location.x-= WINWIDTH;
          }
          if(blood_dots[i].location.y < 0)
          { /* Screw pooling, but I'll leave the code in for anyone that wants to make
               it work.  Good luck to them. */
            // printf("blood_dots[%d] hit pool, killing...", i);
            /*
            add_to_blood_pool(&blood_dots[i]);
            if(average_height > WINHEIGHT - STATUS_BAR_HEIGHT)
            {
              // printf("screen full, initing blood...");
              init_blood();
            }
            */
            blood_dots[i].alive = 0;
          }
          // printf("done.\n");
        }
      }
    }
    //flow_pools();
  }
