#include <math.h>
#include <stdio.h>
#include <string.h>

#include "libsprite/Wlib.h"
#include "data.h"
#include "struct.h"
#include "input.h"
#include "main.h"
#include "highscore.h"
#include "explosions.h"
#include "torps.h"
#include "title.h"

int cheat_6_shot= 0;
int cheat_7_shot= 0;
int keys_set= 0;

g_key_t default_keys[number_of_keys]=
{
  {'6', UPKEY, "up"},
  {'y', DOWNKEY, "down"},
  {'t', LEFTKEY, "left"},
  {'u', RIGHTKEY, "right"},
  {' ', FIREKEY, "fire"},
  {'z', CHANGE_FIRE_KEYA, "change cannon A"},
  {'x', CHANGE_FIRE_KEYB, "change cannon B"},
  {'i', UPKEY, "alt up"},
  {'k', DOWNKEY, "alt down"},
  {'j', LEFTKEY, "alt left"},
  {'l', RIGHTKEY, "alt right"},
  {' ', FIREKEY, "alt fire"},
  {'z', CHANGE_FIRE_KEYA, "alt change cannon A"},
  {'x', CHANGE_FIRE_KEYB, "alt change cannon B"}
};

player_t player_0;

int player_weapon_sum()
  {
    return player_0.weapons[0] + player_0.weapons[1] + player_0.weapons[2]
    + player_0.weapons[3];
  }

void reset_player(player_t* _player_pp,int level)
  {
    _player_pp->location.y= SPACE_HEIGHT-playerShip->height/2;
    _player_pp->location.x= SPACE_WIDTH/2;
    _player_pp->speed.x = 0;
    _player_pp->speed.y = 0;
    _player_pp->acceleration = 1;
    _player_pp->movespeed = MINSPEED;
    _player_pp->weapons[0]= 1 + (cheat_6_shot*level*2)
    + (cheat_7_shot*2*level*2);
    _player_pp->weapons[1]= 0 + (cheat_6_shot*level*2)
    + (cheat_7_shot*2*level*2);
    _player_pp->weapons[2]= 0 + (cheat_6_shot*level*2)
    + (cheat_7_shot*2*level*2);
    _player_pp->weapons[3]= 0 + (cheat_6_shot*level*2)
    + (cheat_7_shot*2*level*2);
    _player_pp->weapon_delays[0] = 4;
    _player_pp->weapon_delays[1] = 8;
    _player_pp->weapon_delays[2] = 4;
    _player_pp->weapon_delays[3] = 8;
    _player_pp->current_weapon = 0;
    _player_pp->wave_amplitude = 8;
    _player_pp->shield= 0;
    _player_pp->got_lemon= 0;
    _player_pp->dead= 0;
    _player_pp->flash= FLASH_TIME;
    _player_pp->safety_bubbles= 0;
    _player_pp->cannon_spread= 1;
    _player_pp->shoot_down_etorps= 0;
    _player_pp->torp_velocity= 0;
    _player_pp->prize_speed_range=3;
    _player_pp->cluster_bombs= 0;
    _player_pp->torp_life = (TORPSPEED + sqrt(TORPSPEED + 8*SPACE_Y_MAX))/2;
    _player_pp->attractions[0] = 0;
    _player_pp->attractions[1] = 0;
    _player_pp->attractions[2] = 0;
  }

void init_player(player_t* _player_pp,int level)
  {
    reset_player(_player_pp,level);
    _player_pp->next_bonus= START_NEXT_BONUS;
    _player_pp->ships= START_SHIPS+level/8;
    _player_pp->score= 0;
    _player_pp->cluster_bombs= 0;
    if(!keys_set)
    {
      memcpy(_player_pp->keys, default_keys, sizeof(_player_pp->keys));
      printf("Keys set by init_player() function.\n");
    }
  }

void check_game_over_keys(void)
  {
    ev_t wev;
    int l=1;
    cheat_7_shot= 0;
    cheat_6_shot= 0;
    while(events_pending())
    {
      wev= next_event();

      switch(wev.type)
      {
        case W_EV_KEY:
          if(score_key(&wev))
          continue;
          switch(wev.key)
          {
            case 'q':
            case 'Q':
              xgal_exit(0);
              break;
            case 'K':
            case 'k':
              l=1;
              break;
            case '1':
            case '2':
            case '3':
            case '4':
            case '5':
            case '6':
            case '7':
            case '8':
            case '9':
              l= wev.key-'0';
              break;
            case '0':
              l=10;
              break;
            case '!':
              l=12;
              break;
            case '@':
              l=14;
              break;
            case '#':
              l=16;
              break;
            case '$':
              l=18;
              break;
            case '%':
              l=20;
              break;
            case '^':
              l=22;
              break;
            case '&':
              l=24;
              break;
            case '*':
              l=26;
              break;
            case '(':
              l=28;
              cheat_6_shot= 1;
              break;
            case ')':
              l=30;
              cheat_7_shot= 1;
              break;
          }
        case W_EV_BUTTON:
          if(!getting_name)
          {
            gameOver = 0;
            level=l;
            init_level();
            init_player(&player_0,level);
            if (cheat_6_shot)
            {
              player_0.weapons[player_0.current_weapon]= 25;
              //player_0.cannon_spread= 3;
              player_0.score-= (int)(player_0.weapons[player_0.current_weapon]
                * 10000);
            }
            if (cheat_7_shot)
            {
              player_0.weapons[player_0.current_weapon]= 52;
              //player_0.cannon_spread= 3;
              player_0.score-= (int)(player_0.weapons[player_0.current_weapon]
                * 10000);
            }
            W_ClearWindow(baseWin);
          }
          break;
      }
    }
  }

double torp_line_angle = M_PI_2;

void check_in_game_keys(void)
  {
    ev_t wev;
    int n;
    while(events_pending())
    {
      wev= next_event();

      switch(wev.type)
      {
        case W_EV_KEY_OFF:
#ifdef DEBUG_KEYS
          printf("key up recieved, checking which key.\n");
          fprintf(OUT_FILE,"Key down: %i\n",wev.type);
#endif
          for(n= 0; n<number_of_keys; n++)
          {
            if(wev.key == player_0.keys[n].chars)
            {
              player_0.pressed_keys &= ~(player_0.keys[n].flags);
            }
          }
          break;
        case W_EV_KEY:
#ifdef DEBUG_KEYS
          fprintf(OUT_FILE,"Key down: %i\n",wev.key);
          printf("checking w_ev_key\n");
#endif
          for(n= 0; n<number_of_keys; n++)
          {
            if(wev.key == player_0.keys[n].chars)
            {
              player_0.pressed_keys |= player_0.keys[n].flags;
            }
          }
          switch(wev.key)
          {
            case 'a':
              torp_line_angle += M_PI/16;
              break;
            case 's':
              torp_line_angle -= M_PI/16;
              break;
            case 'q':
              if(!player_0.dead)
              {
                new_explosion(player_0.location, 2);
                player_0.ships = 0;
                player_0.dead = 1;
              }
              break;
            case 'Q':
              xgal_exit(0);
              break;
            case 'b':
              W_Buffer(baseWin, !W_IsBuffered(baseWin));
              W_ClearWindow(baseWin);
              break;
            case 'p':
              paused=!paused;
              if(paused)
              {
                W_UngrabPointer();
              }
              break;
#ifdef SOUND
            case 's':
              playSounds = !playSounds;
              break;
#endif
#ifdef IM_A_BIG_FAT_CHEATER
            case 'i':
              player_0.score-=500;
              if(player_0.flash >= 0)
              player_0.flash = -2;
              else
              player_0.flash = 0;
              break;
            case 'l':
              player_0.score-=20000;
              {
                int i;
                for(i=0;i<MAXALIENS;i++)
                aliens[i].alive=0;
                if(starspeed != 1)
                level++;
              }
              break;
            case 'c':
              player_0.ships++;
              player_0.score-= 2*BONUSSHIPSCORE;
              break;
            case 'h':
              player_0.score-=5000;
              player_0.shield = SHIELDTIME;
#ifdef SOUND
              play_sound(SND_SHIELD);
#endif
              break;
            case 'w':
              player_0.score-=(int)(player_0.weapon*2000+2000);
              player_0.weapon++;
              break;
#endif /* IM_A_BIG_FAT_CHEATER */
            default:
              break;
          }
      }
    }
  }

void fire_weapon(void)
  {
    switch(player_0.current_weapon)
    {
      case 0:
        fire_torps2(&player_0);
        player_0.fire_times[0]= counter;
        break;
      case 1:
        torp_line(player_0.location, player_0.torp_life
          , TORPSPEED + player_0.torp_velocity, 9 * player_0.cannon_spread
          , player_0.weapons[1], player_0.cluster_bombs, torp_line_angle
          , 0);
        player_0.fire_times[1]= counter;
        break;
      case 2:
        torp_wave(player_0.location, player_0.torp_life
          , player_0.wave_amplitude * player_0.cannon_spread
          , player_0.weapons[2]);
        player_0.fire_times[2]= counter;
        break;
      case 3:
        torp_tree(player_0.location, player_0.torp_life, player_0.weapons[3]
          , 5, M_PI_2);
        player_0.fire_times[3]= counter;
        break;
      default:
        printf("current_weapon out of range, resetting to 0\n");
        player_0.current_weapon = 0;
        fire_torps2(&player_0);
        player_0.fire_times[0]= counter;
        break;
    }
  }

int last_switch_frame = 0;

void change_weapon(int n)
  {
    player_0.current_weapon+= n;
    if(player_0.current_weapon > 3)
    {
      player_0.current_weapon = 0;
    }
    if(player_0.current_weapon < 0)
    {
      player_0.current_weapon = 3;
    }
    /*
      printf("current_weapon is %d\n frames_since_switch is %d\n"
      , player_0.current_weapon, frames_since_switch);
    */
    last_switch_frame= counter;
  }

void move_player()
  {
#if defined (ACCELERATION)
    if(player_0.pressed_keys & LEFTKEY)
    {
      player_0.speed.x -= player_0.acceleration;
    }
    if(player_0.pressed_keys & RIGHTKEY)
    {
      player_0.speed.x += player_0.acceleration;
    }
    if(player_0.pressed_keys & UPKEY)
    {
      player_0.speed.y -= player_0.acceleration;
    }
    if(player_0.pressed_keys & DOWNKEY)
    {
      player_0.speed.x += player_0.acceleration;
    }
    player_0.location.x+=(player_0.speed.x+level/5);
    player_0.location.y+=(player_0.speed.y+level/5);
#else
    if(player_0.pressed_keys & LEFTKEY)
    {
      player_0.location.x -= (player_0.movespeed+((level/5)%10));
    }
    if(player_0.pressed_keys & RIGHTKEY)
    {
      player_0.location.x += (player_0.movespeed+((level/5)%10));
    }
    if(player_0.pressed_keys & UPKEY)
    {
      player_0.location.y -= (player_0.movespeed+((level/5)%10));
    }
    if(player_0.pressed_keys & DOWNKEY)
    {
      player_0.location.y += (player_0.movespeed+((level/5)%10));
    }
#endif /* ACCELERATION */    
  }

void do_player_dead()
  {
    player_0.dead++;
    if((player_0.pressed_keys && player_0.dead>MIN_DEAD_TIME))
    {
      player_0.pressed_keys=0;
      if(player_0.ships<=0)
      {
        gameOver = 1;
        if(check_score(player_0.score))
        {
#ifdef USE_REAL_NAMES
          add_score(getUsersFullName(), player_0.score);
          title_page = 1; pagetimer = 300;
#else
          getting_name = 1;
#endif
        }
      }
      else
      {
        player_0.ships--;
#ifndef NO_DEATH_PENALTY
        reset_player(&player_0,level);
#endif // NO_DEATH_PENALTY
        player_0.dead= 0;
        player_0.location.y= SPACE_HEIGHT-playerShip->height/2;
        player_0.location.x= SPACE_WIDTH/2;
#if defined(PAUSE_ON_DEATH)                    
        paused=1;
#endif /* defined(PAUSE_ON_DEATH)                    */
      }
    }
  }

void do_player()
  {
    static int frames_since_fire, frames_since_switch;
    if(gameOver)
    {
      check_game_over_keys();
    }

    else
    {
      check_in_game_keys();
    }

    if(!paused)
    {
      frames_since_fire = counter - player_0.fire_times[player_0.current_weapon];
      frames_since_switch = counter - last_switch_frame;
      if(!player_0.dead)
      {
        if((player_0.pressed_keys & FIREKEY)
          && (frames_since_fire > player_0.weapon_delays[player_0.current_weapon])
          && (player_0.weapons[player_0.current_weapon] > 0))
        {
          fire_weapon();
        }
      }
      if((player_0.pressed_keys & CHANGE_FIRE_KEYA) && (frames_since_switch > 5))
      {
        change_weapon(1);
      }
      if((player_0.pressed_keys & CHANGE_FIRE_KEYB) && (frames_since_switch > 5))
      {
        change_weapon(-1);
      }
      move_player();
      wrap_object(&player_0.location);
      if(player_0.dead)
      {
        do_player_dead();
      }
      else
      {
        if(player_0.flash > 0)
        {
          player_0.flash--;
        }
        if(player_0.shield > 0)
        {
          player_0.shield--;
        }
      }
    }
  }
