#include <math.h>
#include <stdlib.h>

#include "struct.h"

/* misc math functions */
double sqr(double a){return a*a;}
double cube(double a) {return a*a*a;}
int get_random(int max)
  {
    int random_max = (RAND_MAX / max) * max;
    int new_rand = random_max + 1;
    if(max<1)
    return 20;
    while (new_rand>=random_max)
    {
      new_rand = rand();
    }
    return new_rand%max;
  }

/*--------point operator functions--------*/

point_t point_add(point_t rhs, point_t lhs)
  {
    point_t result = {rhs.x + lhs.x, rhs.y + lhs.y};
    return result;
  }

point_t point_subtract(point_t rhs, point_t lhs)
  {
    point_t result = {rhs.x - lhs.x, rhs.y - lhs.y};
    return result;
  }

point_t scalar_multiply(point_t rhs, double lhs)
  {
    point_t result = {rhs.x * lhs, rhs.y * lhs};
    return result;
  }

point_t scalar_divide(point_t rhs, double lhs)
  {
    point_t result = {rhs.x / lhs, rhs.y / lhs};
    return result;
  }

point_t unit_vector(point_t foo)
  {
    double length = sqrt(sqr(foo.x) + sqr(foo.y));
    return scalar_divide(foo, length);
  }

/*----------------wrap code---------------*/

int wrap_object(point_t* location)
  {
    int wrapped = 0;
    if(location->x > SPACE_X_MAX)
    {
      location->x -= SPACE_X_SIZE;
      wrapped = 1;
    }
    if(location->y > SPACE_Y_MAX)
    {
      location->y -= SPACE_Y_SIZE;
      wrapped = 1;
    }
    if(location->x < SPACE_X_MIN)
    {
      location->x += SPACE_X_SIZE;
      wrapped = 1;
    }
    if(location->y < SPACE_Y_MIN)
    {
      location->y += SPACE_Y_SIZE;
      wrapped = 1;
    }
    return wrapped;
  }
