#include <stdio.h>
#include <string.h>

#include "libsprite/Wlib.h"
#include "defs.h"
#include "images.h"
#include "data.h"
#include "struct.h"
#include "paths.h"
#include "draw.h"
#include "prize.h"
#include "highscore.h"

W_Image *pauseImage, *titleImage;
int pausex, pausey, pauseyspeed=1;
int show_pause= 1;

void do_pause()
{
    if((pausey < pauseImage->height/2)
      || ((pausey+(pauseImage->height/2)) >= WINHEIGHT - STATUS_BAR_HEIGHT))
	pauseyspeed = -pauseyspeed;
    pausey+=pauseyspeed;
}

void center_text(char *text, int y, W_Color color)
{
/*
    W_MaskText(baseWin, WINWIDTH/2 - ((strlen(text)*W_Textwidth)/2)-1, y+1, W_Black,
	       text, strlen(text), W_RegularFont);
*/
    W_MaskText(baseWin, WINWIDTH/2 - ((strlen(text)*W_Textwidth)/2), y, color,
	       text, strlen(text), W_RegularFont);
}

static void show_points()
{
  int image_index, bonus_text_y;
  int type_i;

  char buf[40];

  for (image_index=0;image_index<ALIENSHAPES;image_index++)
  {
    draw_image_wrapper
      (baseWin, WINWIDTH/2 - 30, 100+image_index*21,0,
        getImage(alien_shape[image_index]), W_Red);

    type_i=type_map[image_index];
    switch(type_i)
    {
      case FLAG_SHIP_0:
      case FLAG_SHIP_11:
        sprintf(buf," (1<<escorts)*500 ");
        break;
      default:
        sprintf(buf, " %4i , %4i , %4i",10*type_i,20*type_i,40*type_i);
    }
    mask_text_wrapper(baseWin, WINWIDTH/2, 105+image_index*21,
      W_Yellow, buf, strlen(buf), W_RegularFont);
  }
  bonus_text_y = 220+image_index*21;
  center_text("Bonus ships at 20,000, 50,000, then every 50,000.",
    bonus_text_y, W_Green);
}

static void show_help()
{
    int top = 220;

    center_text("         Keyboard controls           ", top, W_Red);
    center_text("  left/right arrow   move            ", top+10, W_Yellow);
    center_text("  space bar          fire            ", top+20, W_Yellow);
    center_text("  p                  pause           ", top+30, W_Cyan);
    center_text("  q                  end game        ", top+40, W_Cyan);
    center_text("  Q                  quick quit      ", top+50, W_Cyan);
    center_text("  k                  keyboard control", top+60, W_Cyan);
    center_text("  m                  mouse control   ", top+70, W_Cyan);
#ifdef SOUND
    center_text("  s                  toggle sound    ", top+80, W_Cyan);
#endif
	  
    center_text("Bonus ships at 20,000, 50,000, then every 50,000.",
      top+100, W_Green);
}

void do_title()
{
  int ty;
  char vbuf[10];
  W_DrawImage(baseWin, WINWIDTH/2 - titleImage->width/2, 50, 0, titleImage, W_Red);
  sprintf(vbuf, "v%s", VERSION);
  center_text(vbuf, 40+titleImage->height, W_Yellow);

  ty = 60 + titleImage->height;
  if(getting_name)
  {
    title_page = 0;
  }

  switch(title_page)
  {
    case 0:
      center_text("Copyright (c) 1995,1996   Joe Rumsey (see copyright.h)", ty, W_Green);
      ty+= W_Textheight;
      center_text("Copyright (c) 1989   Kevin P. Smith, Scott Silvey (see copyright2.h)", ty, W_Green); ty+= W_Textheight;

      if(!getting_name)
      {
        show_help();
      }
      break;
    case 1:
      show_scores();
      break;
    case 2:
      show_prize_list(0);
      break;
    case 3:
      show_prize_list(1);
      break;
    case 4:
      show_prize_list(2);
      break;
    default:
      show_points();
      break;
  }

  center_text("Press k for keyboard control, m for mouse", WINHEIGHT - 2*W_Textheight, W_Yellow);
  center_text("Or q to quit", WINHEIGHT - W_Textheight, W_Yellow);
  pagetimer--;
  if(!pagetimer)
  {
    W_ClearWindow(baseWin);
    title_page++;
    title_page%=5;
    pagetimer = 300;
  }
}

void init_titles()
{
    titleImage = getImage(I_TITLE);

    pauseImage = getImage(I_PAUSE);
    pausex = WINWIDTH/2;
    pausey = WINHEIGHT/2;
    pauseyspeed = 3;
}
